<?php
// no direct access
defined('_JEXEC') or die('Restricted access');
//JHTML::_('behavior.tooltip');
jimport('joomla.plugin.plugin');
class plgContentGlossary extends JPlugin
{
    function onPrepareContent (&$article, &$params, $limitstart)
    {
        global $mainframe;
        if ($mainframe->isAdmin()) {
            return;
        }
        $db = & JFactory::getDBO();
        JHTML::_('behavior.tooltip');
        $field = $this->params->get('field');
        if (! $field) {
            JError::raiseWarning(230, 
            'Glossary plugin - parameters not set. Edit plugin or unpublish it.');
            return;
        }
        $where = array();
        $sections = $this->params->get('categories');
        settype($sections, 'array');
        $sections = array_values($sections);
        JArrayHelper::toInteger($sections);
        if (! empty($sections[0])) {
            $sections = implode(',', $sections);
            $where[] = "r.id IN(
        	SELECT record_id FROM #__js_res_record_category WHERE catid IN (
          		SELECT id FROM #__js_res_category WHERE id IN ({$sections}) OR section_id IN ({$sections})))";
        }
        IF ($this->params->get('types')) {
            $where[] = "r.type_id = " . $this->params->get('types');
        }
        if (! $where) {
            JError::raiseWarning(230, 
            'Glossary plugin - parameters not set. Edit plugin or unpublish it.');
            return;
        }
        $w = ' WHERE ' . implode(' AND ', $where);
        $sql = "
				SELECT r.id, r.title, f.field_value, c.catid  
				FROM  #__js_res_record AS r
			LEFT JOIN #__js_res_record_values AS f ON f.record_id = r.id AND f.field_id = {$field} 
        	LEFT JOIN #__js_res_record_category AS c on c.record_id = r.id 
        {$w} GROUP BY r.id";
        $key = md5($sql);
        static $result = array();
        if (! isset($result[$key])) {
            JHTML::_('behavior.tooltip');
            $db->setQuery($sql);
            $result[$key] = $db->loadObjectList();
            $document = &JFactory::getDocument();
            $css = '.glossary{'.$this->params->get('css', "cursor:pointer; background-color:yellow; text-decoration:underline;").'}';
            $document->addStyleDeclaration($css);
            if ($this->params->get('link')) {
                require_once (JPATH_ROOT . DS . 'administrator' . DS .
                 'components' . DS . 'com_resource' . DS . 'library' . DS .
                 'helper.php');
            }
        }
        foreach ($result[$key] as $vall) {
            if ($this->params->get('link')) {
                $link = MEUrl::link_record($vall->id, $vall->catid);
                $string = sprintf(
                ' <a href="%s"><span class="glossary hasTip" title="%s::%s">\\1</span></a> ', 
                $link, htmlspecialchars($vall->title), 
                htmlspecialchars($vall->field_value));
            } else {
                $string = sprintf(
                ' <span class="glossary hasTip" title="%s::%s">\\1</span> ', 
                htmlspecialchars($vall->title), 
                htmlspecialchars($vall->field_value));
            }
            $article->text = preg_replace(
            "/ (" . preg_quote($vall->title) . ") /isU", $string, $article->text);
        }
    }
}
?>